<template>
  <div
    class="calendar_cell"
    @mouseover="onCellHovered"
    @mousedown="handleSelection"
    v-bind:style="{ backgroundColor: backgroundColor, color: textColor }"
  >
    {{ day.date() }}
  </div>
</template>
<script>
export default {
  name: "CalendarCell",
  props: {
    day: { type: Object },
    selectedDayOfWeek: { type: Object },
    isMouseDown: { type: Boolean }
  },
  data() {
    return {
      isSelected: false
    };
  },
  mounted() {
    if (this.selectedDayOfWeek.dayNumber === this.day.day()) {
      this.isSelected = true;
      this.$emit("addSelectedDay", this.day);
    }
  },
  computed: {
    backgroundColor() {
      return this.isSelected ? "#77a6f7" : "#ffffff";
    },
    textColor() {
      return this.isSelected ? "#ffffff" : "#2c3e50";
    }
  },
  methods: {
    onCellHovered() {
      if (this.isMouseDown) this.handleSelection();
    },
    handleSelection() {
      this.isSelected = !this.isSelected;
      if (this.isSelected) this.$emit("addSelectedDay", this.day);
      else this.$emit("deleteSelectedDay", this.day);
    }
  },
  watch: {
    selectedDayOfWeek(newSelectedDayOfWeek) {
      if (newSelectedDayOfWeek.dayNumber === this.day.day()) {
        if (!this.isSelected) this.$emit("addSelectedDay", this.day);
        this.isSelected = true;
      } else if (this.isSelected) {
        this.isSelected = false;
        this.$emit("deleteSelectedDay", this.day);
      }
    }
  }
};
</script>
